on 1:load {
  if ($version < 6.16) {
    echo -a you need mirc version 6.16 or newer.
    .unload -rs $+($scriptdir,quickpic.mrc)
  }
  else {
    resetdirs
    echo -a welcome to quickpic. type /quickpic to begin.
  }
}
alias -l resetdirs {
  if ((!%qp.wwwroot) || (!%qp.domain)) qp.setup
  if (!%qp.outputdir) %qp.outputdir = %qp.wwwroot
  if (!%qp.imagedir) %qp.imagedir = c:\
}
alias quickpic {
  if ($window(@quickpic)) window -c @quickpic
  window -pfdho +dL @quickpic $iif(%qp.guix,%qp.guix,$calc($window(-1).w - 200)) $iif(%qp.guiy,%qp.guiy,1) 70 13
  drawrect -f @quickpic 4 1 0 0 20 14
  drawrect -f @quickpic 12 1 20 0 20 14
  drawrect -f @quickpic 10 1 40 0 30 14
  drawtext @quickpic 0 Arial 10 1 1 PIC
  drawtext @quickpic 0 Arial 10 21 1 DIR
  drawtext @quickpic 0 Arial 10 41 1 LINKS
  setlayer 170 @quickpic
  resetdirs
}
alias unpic {
  if ($window(@quickpic)) {
    %qp.guix = $window(@quickpic).dx
    %qp.guiy = $window(@quickpic).dy
    window -c @quickpic
  }
}
alias quickpic.uninstall {
  var %a = $?!="Are you sure?"
  if (%a) {
    unset %qp.*
    .unload -rs $+($scriptdir,quickpic.mrc)
    echo -a quickpic uninstalled.
  }
}
menu @quickpic {
  sclick {
    if ($timer(moveqp)) .timermoveqp off
    else if ($inrect($mouse.x,$mouse.y,0,0,20,14)) dodrop
    else if ($inrect($mouse.x,$mouse.y,20,0,20,14)) dodrop -d
    else qplinks
  }
  move { .timermoveqp -m 0 20 moveqp }
  setup { qp.setup }
  -
  close { unpic }
}
dialog qpoptions {
  title "Choose your options"
  option pixels
  size -1 -1 300 265
  
  button "Go!",1,120 245 60 20,ok
  button "Cancel",99,250 245 50 20,cancel

  radio "Unchanged",2,10 20 140 30,push group
  radio "Original/Recompressed",3,150 20 140 30,push
  radio "640x480",4,10 50 70 30,push
  radio "800x600",5,80 50 70 30,push
  radio "1024x768",6,150 50 70 30,push
  radio "1280x960",7,220 50 70 30,push
  
  edit "0",10,-3 -3 0 0,result
  
  scroll "",20,10 110 280 17,horizontal range 1 100
  
  text "worst",30,10 130 30 15
  text "best",31,240 130 49 15,right
  
  box "Resolution",50,2 1 296 85
  box "Quality",51,2 90 296 60
  box "Misc",52,2 154 296 85
  
  check "Prompt to rename file(s)",70,10 170 280 15
  check "Create index.html for multiple files",71,10 185 280 15
  check "Overwrite existing files",72,10 200 250 15
  check "Recurse subdirectories (in DIR mode)",73,10 215 250 15
}
on 1:dialog:qpoptions:sclick:* {
  if ($did == 1) {
    var %rw = 0
    if ($did(qpoptions,3).state == 1) %rw = -1
    if ($did(qpoptions,4).state == 1) %rw = 640
    if ($did(qpoptions,5).state == 1) %rw = 800
    if ($did(qpoptions,6).state == 1) %rw = 1024
    if ($did(qpoptions,7).state == 1) %rw = 1280
    did -o qpoptions 10 1 %rw $did(qpoptions,20).sel $did(qpoptions,70).state $did(qpoptions,71).state $did(qpoptions,72).state $did(qpoptions,73).state
  }
  if ($did == 2) did -b qpoptions 20
  if (($did > 2) && ($did <= 7)) did -e qpoptions 20
}
on 1:dialog:qpoptions:init:0 {
  did -c qpoptions 20 60
  did -c qpoptions 2
  did -b qpoptions 20
}

dialog rename {
  title "Rename Image"
  option pixels
  size -1 -1 300 45
  
  button "Rename",1,75 22 50 21,ok
  button "Cancel",2,125 22 50 21,cancel
  button "Cancel all",3,175 22 50 21
  
  edit "",10,1 1 298 20,result
}
on 1:dialog:rename:init:0 {
  dialog -s rename $calc(($window(-1).w / 2) - 150) 10 300 45
  did -f rename 10
}
on 1:dialog:rename:sclick:* {
  if ($did == 3) {
    %qp.tmp.rename = $false
    dialog -c rename
  }
}
alias -l dodrop {
  var %sfile = $iif($1 == -d,$sdir(%qp.imagedir,Select input directory),$msfile(%qp.imagedir,Select image files)), %ddir, %options, %dfile, %mode = $iif($1 == -d,dir,pic), %result, %index, %files
  if (%sfile) {
    .remove qpfiles.dat
    if (%mode == pic) {
      if (%sfile > 1) {
        var %a = 0
        while (%a < %sfile) {
          inc %a
          if ($right($msfile(%a),4) == .jpg) write qpfiles.dat $msfile(%a)
        }
      }
      else %sfile = $msfile(1)
      %qp.imagedir = $nofile($msfile(1))
    }
    else %qp.imagedir = %sfile
    %ddir = $sdir(%qp.outputdir,Select the destination directory)
    if (%ddir) {
      %index = $+(",%ddir,index.html,")
      %options = $dialog(qpoptions,qpoptions,-1)
      if ($numtok(%options,32) < 6) halt
      tokenize 32 %options
      %qp.tmp.resize = $1
      %qp.tmp.quality = $2
      %qp.tmp.rename = $3
      %qp.tmp.makeindex = $4
      %qp.tmp.overwrite = $5
      %qp.tmp.recurse = $6
      if (%mode == dir) {
        if (%qp.tmp.recurse == 1) %files = $findfile(%sfile,*.jpg,0,write qpfiles.dat $1-)
        else %files = $findfile(%sfile,*.jpg,0,1,write qpfiles.dat $1-)
        if (%files == 0) {
          %files = $input(There are no JPEG files in this directory.,o,Notice)
          halt
        }
      }
      if ($exists(qpfiles.dat)) {
        if (%qp.tmp.makeindex) {
          write -c %index
          write %index <html><head><title>Pics</title></head><body><font face="Arial" size="-1">
        }
        %qp.tmp.totalsizebegin = 0
        %qp.tmp.totalpixels = 0
        %qp.tmp.totalsizeend = 0
        %qp.tmp.num = 0
        %qp.tmp.numfiles = $lines(qpfiles.dat)
        %qp.tmp.outdir = %ddir
        picloop
      }
      else if (%mode == pic) {
        %dfile = %ddir $+ $nopath(%sfile)
        %result = $dopic(%sfile,%dfile)
        unset %qp.tmp.*
      }
      %qp.outputdir = %ddir
    }
  }
}
alias -l picloop {
  var %infile, %outfile, %index = $+(",%qp.tmp.outdir,index.html,"), %result
  if (%qp.tmp.num < %qp.tmp.numfiles) {
    inc %qp.tmp.num
    %infile = $read(qpfiles.dat,%qp.tmp.num)
    inc %qp.tmp.totalsizebegin $file(%infile).size
    inc %qp.tmp.totalpixels $calc($pic(%infile).width * $pic(%infile).height)
    %outfile = %qp.tmp.outdir $+ $nopath(%infile)
    %result = $dopic(%infile,%outfile)
    if (%result) {
      if (%qp.tmp.makeindex) write %index <a href=" $+ $nopath(%result) $+ "> $+ $nopath(%result) $+ </a> ( $+ $round($calc($file(%result).size / 1024),2) KB)<br>
      inc %qp.tmp.totalsizeend $file(%result).size
    }
    progress $calc(%qp.tmp.num / %qp.tmp.numfiles) %qp.tmp.numfiles
    .timerpicloop -m 1 30 picloop
  }
  else {
    progress 1 %qp.tmp.numfiles Compression saved $round($calc((%qp.tmp.totalsizebegin - %qp.tmp.totalsizeend) / 1024),0) $+ KB. Processed $round($calc(%qp.tmp.totalpixels / 1024 / 1024),2) megapixels.
    .clipboard $replace(%qp.tmp.outdir,%qp.wwwroot,%qp.domain $+ /,\,/,$chr(32),$chr(37) $+ 20)
    if (%qp.tmp.makeindex) write %index </body></html>
    writelink $cb(1)
    unset %qp.tmp.*
  }
}
alias -l dopic {
  var %w = $pic($1).width, %h = $pic($1).height, %width, %height, %rw, %rh, %input = $1, %output = $2, %switches, %rename, %overwrite
  %rw = %qp.tmp.resize
  %rh = $calc((%rw * 3) / 4)
  if (%qp.tmp.resize <= 0) {
    %rw = %w
    %width = %w
    %rh = %h
    %height = %h
  }
  else {
    if (%w > %h) {
      %width = %rw
      %height = $round($calc((%h / %w) * %rw),0)
    }
    else {
      %height = %rw
      %width = $round($calc((%w / %h) * %rw),0)
    }
  }
  if (%qp.tmp.rename) %switches = -pfdh +dL @resize $calc(($window(-1).w / 2) - (%rw / 2)) 30
  else %switches = -pfdhn +dL @resize 0 0
  window %switches %width %height
  drawpic -sm @resize 0 0 %width %height $+(",%input,")
  if (%qp.tmp.rename) {
    %rename = $dialog(rename,rename,-1)
    if (%rename) %output = $+($nofile(%output),%rename,.jpg)
  }
  if (($exists(%output)) && (!%qp.tmp.overwrite)) %overwrite = $?!="Overwrite existing file? ( $+ $nopath(%output) $+ )"
  if (%overwrite) .remove $+(",%output,")
  if ((($exists(%output)) && (!%qp.tmp.overwrite) && (%overwrite)) || (($exists(%output)) && (%qp.tmp.overwrite)) || (!$exists(%output))) {
    if (%qp.tmp.resize != 0) drawsave [ -b32q $+ [ %qp.tmp.quality ] ] @resize $+(",%output,")
    else if (!$exists(%output)) .copy $+(",%input,") $+(",%output,")
    .clipboard $replace(%output,%qp.wwwroot,%qp.domain $+ /,\,/,$chr(32),$chr(37) $+ 20)
    writelink $cb(1)
  }
  else %output = $null
  window -c @resize
  return %output
}
alias moveqp {
  window -pfdho +dL @quickpic $calc($mouse.dx - 2) $calc($mouse.dy - 2) 70 13
}
alias -l writelink {
  write qplinks.dat $1-
  if ($dialog(qplinks)) did -a qplinks 10 $1-
}
alias -l qplinks {
  if (!$dialog(qplinks)) dialog -dm qplinks qplinks
  else dialog -k qplinks
}
dialog qplinks {
  title "Image Links"
  option pixels
  size -1 -1 300 200
  
  button "ok",1,-2 -2 0 0,ok
  button "Clear",2,200 180 50 20
  button "Launch",3,125 180 50 20
  button "Close",4,250 180 50 20,cancel
  
  list 10,1 1 298 185,vsbar
}
on 1:dialog:qplinks:sclick:2 {
  .remove qplinks.dat
  did -r qplinks 10
}
on 1:dialog:qplinks:sclick:3 {
  if ($did(qplinks,10).seltext) run $did(qplinks,10).seltext
}
on 1:dialog:qplinks:dclick:10 {
  .clipboard $did(qplinks,10).seltext
}
on 1:dialog:qplinks:init:0 {
  if ($exists(qplinks.dat)) loadbuf -o qplinks 10 qplinks.dat
}
dialog qpsetup {
  title "quickpic setup"
  option pixels
  size -1 -1 400 75
  
  button "OK",1,320 55 40 20,ok
  button "Set",2,350 5 50 20
  button "Cancel",3,360 55 40 20,cancel
  button "Detect",4,350 30 50 20
  
  text "wwwroot dir:",20,5 6 75 20,right
  text "domain:",21,5 31 75 20,right
  
  edit "",40,85 5 260 20,read
  edit "",41,85 30 260 20
}
alias qp.setup {
  if (!$dialog(qpsetup)) dialog -m qpsetup qpsetup
}
on 1:dialog:qpsetup:init:0 {
  did -o qpsetup 40 1 %qp.wwwroot
  did -o qpsetup 41 1 %qp.domain
}
on 1:dialog:qpsetup:sclick:1 {
  %qp.wwwroot = $did(qpsetup,40)
  %qp.domain = $did(qpsetup,41)
}
on 1:dialog:qpsetup:sclick:2 {
  var %temp = $sdir(c:\,Select your www root directory)
  if (%temp) did -o qpsetup 40 1 %temp
}
on 1:dialog:qpsetup:sclick:4 {
  did -o qpsetup 41 1 http:// $+ $ip
}
alias -l progress {
  var %per = $1, %files = $2, %msg = $3-
  if (!$window(@progress)) {
    window -pfdho +dL @progress 10 10 400 30
    drawrect -f @progress 1 1 0 0 400 30
    drawtext @progress 0 Arial 10 1 1 Processing %files images...
    setlayer 170 @progress
  }
  if (!%msg) drawrect -f @progress 4 1 5 18 $round($calc(%per * 390),0) 8
  else {
    drawtext @progress 0 Arial 10 120 1 Done.
    drawrect -f @progress 1 1 5 18 490 8
    drawtext @progress 0 Arial 10 1 15 %msg
    drawrect @progress 0 1 375 5 20 20
    drawline @progress 0 2 380 10 390 20
    drawline @progress 0 2 380 20 390 10
  }
}
menu @progress {
  sclick {
    if ($inrect($mouse.x,$mouse.y,375,5,20,20)) window -c @progress
  }
}
menu status,channel,query {
  quickpic { quickpic }
}
